guiKeyMouseEvents = {};

function guiKeyMouseEvents:setKeyMouse(self, unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)
	if unicode ~= nil then		
		if g_currentMission.guiMenue.on then guiKeyMouseEvents:setKey(self, unicode, sym, modifier, isDown);end;
	else		
		if g_currentMission.guiMenue.on then guiKeyMouseEvents:setMouse(self, posX, posY, isDown, isUp, button);end;
	end;
end;

function guiKeyMouseEvents:setKey(self, unicode, sym, modifier, isDown)
	
end;

function guiKeyMouseEvents:setMouse(self, posX, posY, isDown, isUp, button)	
	local infoText = false;
	local helpText = false;
	local markerColorButton = false;
	if g_currentMission.guiMenue.clickAreas ~= nil and #g_currentMission.guiMenue.clickAreas > 0 then		
		for a=1, #g_currentMission.guiMenue.clickAreas do
			if g_currentMission.guiMenue.clickAreas[a] ~= nil then				
				if guiMenue:mouseIsInArea(posX, posY, unpack(g_currentMission.guiMenue.clickAreas[a])) then					
					if button == Input.MOUSE_BUTTON_LEFT and isDown then
						if g_currentMission.guiMenue.clickAreas[a].isGuiText then
							guiKeyMouseEvents:setGuiMouseClickIsGuiMaster(self, g_currentMission.guiMenue.clickAreas[a].whatClick, posX, posY);
						else
							guiKeyMouseEvents:setGuiMouseClickModPage(self, g_currentMission.guiMenue.clickAreas[a]);
						end;
						if g_currentMission.guiMenue.on and g_currentMission.guiMenue.clickAreas[a].markerColor ~= nil then
							g_currentMission.guiMenue.markerColorButton = {posX=g_currentMission.guiMenue.clickAreas[a][1];posY=g_currentMission.guiMenue.clickAreas[a][3];width=g_currentMission.guiMenue.clickAreas[a].markerColorWidth;height=g_currentMission.guiMenue.clickAreas[a].markerColorHeight;colorName=tostring(g_currentMission.guiMenue.clickAreas[a].colorName);overlayName=tostring(g_currentMission.guiMenue.clickAreas[a].overlayName)};
							markerColorButton = true;
						end;
						break;
					else
						if g_currentMission.guiMenue.clickAreas[a].getHelpText ~= nil and string.len(tostring(g_currentMission.guiMenue.clickAreas[a].getHelpText)) > 0 then
							g_currentMission.guiMenue.helpText.posX = posX;
							g_currentMission.guiMenue.helpText.posY = posY;
							g_currentMission.guiMenue.helpText.txt = tostring(g_currentMission.guiMenue.clickAreas[a].getHelpText);
							if g_currentMission.guiMenue.clickAreas[a].helpSize ~= nil then
								g_currentMission.guiMenue.helpText.size = g_currentMission.guiMenue.clickAreas[a].helpSize;
							else
								g_currentMission.guiMenue.helpText.size = g_currentMission.guiMenue.default.helpTextSize;
							end;
							helpText = true;							
						end;
						if g_currentMission.guiMenue.clickAreas[a].getInfoText ~= nil and string.len(tostring(g_currentMission.guiMenue.clickAreas[a].getInfoText)) > 0 then							
							g_currentMission.guiMenue.infoText.txt = tostring(g_currentMission.guiMenue.clickAreas[a].getInfoText);
							if g_currentMission.guiMenue.clickAreas[a].infoSize ~= nil then
								g_currentMission.guiMenue.infoText.size = g_currentMission.guiMenue.clickAreas[a].infoSize;
							else
								g_currentMission.guiMenue.infoText.size = g_currentMission.guiMenue.default.infoTextSize;
							end;
							infoText = true;							
						end;
						if g_currentMission.guiMenue.on and g_currentMission.guiMenue.clickAreas[a].markerColor ~= nil then
							g_currentMission.guiMenue.markerColorButton = {posX=g_currentMission.guiMenue.clickAreas[a][1];posY=g_currentMission.guiMenue.clickAreas[a][3];width=g_currentMission.guiMenue.clickAreas[a].markerColorWidth;height=g_currentMission.guiMenue.clickAreas[a].markerColorHeight;colorName=tostring(g_currentMission.guiMenue.clickAreas[a].colorName);overlayName=tostring(g_currentMission.guiMenue.clickAreas[a].overlayName)};
							--g_currentMission.guiMenue.markerColorButton.posX = g_currentMission.guiMenue.clickAreas[a][1];
							--g_currentMission.guiMenue.markerColorButton.posY = g_currentMission.guiMenue.clickAreas[a][3];
							--g_currentMission.guiMenue.markerColorButton.width = g_currentMission.guiMenue.clickAreas[a].markerColorWidth;
							--g_currentMission.guiMenue.markerColorButton.height = g_currentMission.guiMenue.clickAreas[a].markerColorHeight;
							--g_currentMission.guiMenue.markerColorButton.colorName = tostring(g_currentMission.guiMenue.clickAreas[a].colorName);
							--g_currentMission.guiMenue.markerColorButton.overlayName = tostring(g_currentMission.guiMenue.clickAreas[a].overlayName);
							markerColorButton = true;
						end;
						break;
					end;					
				end;
			end;
		end;
	end;
	if not markerColorButton then
		g_currentMission.guiMenue.markerColorButton = {posX=0;posY=0;width=0,height=0,colorName="",overlayName=""};
	end;
	if not infoText then		
		g_currentMission.guiMenue.infoText.txt = "";		
	end;
	if not helpText then		
		g_currentMission.guiMenue.helpText.txt = "";
		g_currentMission.guiMenue.helpText.posX = 0;
		g_currentMission.guiMenue.helpText.posY = 0;
	end;
end;

function guiKeyMouseEvents:setGuiMouseClickIsGuiMaster(self, whatClick, posX, posY)
	local modMenueName = g_currentMission.guiMenue.modMenueTable[g_currentMission.guiMenue.modMenue];	
	if whatClick == "closeMenue" then
		if g_currentMission.guiMenue.on then
			g_currentMission.guiMenue.on = false;
			g_currentMission.guiMenue.clickAreas = {};							
		end;
	elseif whatClick == "saveButton" and modMenueName ~= nil and g_currentMission.guiMenue.mod[modMenueName].tempSave then
		g_currentMission.guiMenue.mod[g_currentMission.guiMenue.modMenueTable[g_currentMission.guiMenue.modMenue]].save	= true;		
	elseif whatClick == "nextModMenueLeft" and modMenueName ~= nil then
		g_currentMission.guiMenue.modMenue = g_currentMission.guiMenue.modMenue-1;
		if g_currentMission.guiMenue.modMenue < 1 then
			g_currentMission.guiMenue.modMenue = #g_currentMission.guiMenue.modMenueTable;		
		end;
	elseif whatClick == "nextModMenueRight" and modMenueName ~= nil then
		g_currentMission.guiMenue.modMenue = g_currentMission.guiMenue.modMenue+1;
		if g_currentMission.guiMenue.modMenue > #g_currentMission.guiMenue.modMenueTable then
			g_currentMission.guiMenue.modMenue = 1;		
		end;
	elseif whatClick == "nextPageLeft" and modMenueName ~= nil then
		g_currentMission.guiMenue.mod[modMenueName].page[g_currentMission.guiMenue.mod[modMenueName].lastPage].openDownUpText = false;
		g_currentMission.guiMenue.mod[modMenueName].lastPage = g_currentMission.guiMenue.mod[modMenueName].lastPage-1;		
		if g_currentMission.guiMenue.mod[modMenueName].lastPage < 1 then
			g_currentMission.guiMenue.mod[modMenueName].lastPage = #g_currentMission.guiMenue.mod[modMenueName].page;		
		end;
	elseif whatClick == "nextPageRight" and modMenueName ~= nil then
		g_currentMission.guiMenue.mod[modMenueName].page[g_currentMission.guiMenue.mod[modMenueName].lastPage].openDownUpText = false;
		g_currentMission.guiMenue.mod[modMenueName].lastPage = g_currentMission.guiMenue.mod[modMenueName].lastPage+1;
		if g_currentMission.guiMenue.mod[modMenueName].lastPage > #g_currentMission.guiMenue.mod[modMenueName].page then
			g_currentMission.guiMenue.mod[modMenueName].lastPage = 1;		
		end;
	end;
	g_currentMission.guiMenue.downUp.open = false;
	g_currentMission.guiMenue.downUp.line = 0;
end;

function guiKeyMouseEvents:setGuiMouseClickModPage(self, areaTable)
	local modMenueName = g_currentMission.guiMenue.modMenueTable[g_currentMission.guiMenue.modMenue];
	--{line=0,button=0,buttonDouble=0,openDownUpLine=0};
	if g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].returnClick.line == 0 then
		g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].returnClick.line = Utils.getNoNil(areaTable.line, 0);
		g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].returnClick.button = Utils.getNoNil(areaTable.button, 0);
		g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].returnClick.buttonDouble = Utils.getNoNil(areaTable.buttonDouble, 0);
		g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].returnClick.openDownUpLineString = Utils.getNoNil(areaTable.openDownUpLineString, "");
		if areaTable.isOpenDownUp then
			if g_currentMission.guiMenue.downUp.open and g_currentMission.guiMenue.downUp.line ~= areaTable.line then return;end;
			if g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].openDownUpText then				
				if string.len(g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].returnClick.openDownUpLineString) <= 0 then
					g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].openDownUpText = false;
					g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].openDownUpLine = 0;
					g_currentMission.guiMenue.downUp.open = false;
					g_currentMission.guiMenue.downUp.line = 0;
				else
					g_currentMission.guiMenue.mod[modMenueName].tempSave=true;
				end;				
			else
				g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].openDownUpText = true;
				g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].openDownUpLine = Utils.getNoNil(areaTable.line, 0);
				g_currentMission.guiMenue.downUp.open = true;
				g_currentMission.guiMenue.downUp.line = Utils.getNoNil(areaTable.line, 0);				
			end;
		else
			g_currentMission.guiMenue.downUp.open = false;
			g_currentMission.guiMenue.downUp.line = 0;
			g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].openDownUpText = false;
			g_currentMission.guiMenue.mod[tostring(modMenueName)].page[areaTable.page].openDownUpLine = 0;	
		end;
		if not areaTable.isOpenDownUp then g_currentMission.guiMenue.mod[modMenueName].tempSave=true;end;		
	end;
end;